// -*- Java -*-
// Copyright 1999 Greg Spencer (greg_spencer@acm.org)

function record(name, path, mod_date, version, 
                action, change_num, file_type, branch_path) {
  this.name = name;
  this.mod_date = new Date();
  this.file_type = file_type;
  this.path = path;
  this.branch_path = branch_path;
  if (file_type == "directory") {
    this.mod_date.setTime(0);
    this.date_string = "&nbsp;";
    this.action = "&nbsp;";
    this.version = -1;
    this.change_num = -1;
    this.isdir = 1;
  }
  else {
    this.mod_date.setTime(mod_date*1000);
    var year = this.mod_date.getYear();
    var hours = this.mod_date.getHours();
    var minutes = this.mod_date.getMinutes();
    if (year < 100) year += 1900;
    var hourpad = "";
    var minpad = ":";
    var ampm = "a";
    if (hours >12) {
        hours -= 12;
        ampm = "p";
    }
    if (hours == 12) ampm = "p";
    if (hours == 0) hours = 12;
    if (hours < 10) hourpad = "0";
    if (minutes < 10) minpad = ":0";
    
    this.date_string = (this.mod_date.getMonth()+1) + "/" +
        this.mod_date.getDate() + "/" +
            year + " " +
                hourpad + hours + minpad + minutes + ampm;
    this.version = version;
    this.action = action;
    this.change_num = change_num;
    this.isdir = 0;
  }
}

