#!/bin/perl5
# -*- Perl -*-

# This is the configuration file for the p4dir utils.
# modify this to match your situation.

package p4Config;

BEGIN{
    # This adds the perl libraries to the search path
    # for perl includes.  This may not be necessary at your site,
    # but doesn't hurt in any case.
    push(@main::INC,"/usr/freeware/lib/perl5/sgi_perl","/usr/freeware/lib/perl5");

    # This is the perforce server name and port
    $ENV{P4PORT} = "singe.platinum.com:1666";

    # This is the name of the client that you wish to use This client
    # will never be sync'd anywhere, and it doesn't really matter what
    # it's client spec is, since it queries everything using the
    # "//depot" syntax.
    $ENV{P4CLIENT} = "p4browse";

    # This is the user that the server will run under.
    $ENV{P4USER} = "gspencer";

    # This path must include the p4 executable
    $ENV{PATH} .= ":/usr/local/bin:/usr/freeware/bin";

    # Set this string to whatever "this is confidential" string you
    # want.  It will be displayed at the top and bottom of each
    # syntax-highlighted page, so it should probably be really short.
    $ENV{CONFIDENTIAL} = "PTI Confidential";

    # This is the *http* location of the folder and magnifier images
    # for the directory listing.
    $main::wwwimages = "/images";

    # This is the *http* location of the javascript files
    $main::wwwscripts = "/scripts";

    # This is the *http* location of the cgi-bin directory
    $main::wwwcgibin = "/cgi-bin";

    # This figures out where on the local filesystem the cgi-bin
    # executables are so that they can be invoked locally.
    ($main::cgipath = $0)=~ s:/([^/]+)$::;

    # This figures out the name of the script that is currently
    # running.  This is used to determine what "mode" the p4dir and
    # p4file2html scripts are in (browse/no browse, data/no data).
    ($main::scriptname = $1) =~ s/\.pl$//;

    # These are the basenames of the main scripts, as they are called
    # in the cgi-bin directory (both flavors of each).  There is
    # probably no need to change these, unless you changed them when
    # you installed the distribution because of a name conflict.
    $main::p4dirName = "p4dir";
    $main::p4dirbrowseName = "p4dirbrowse";
    $main::p4browseName = "p4browse";
}

1;
